;MASM/TASM Win32 coding tutorial pt. 1.2beta  -  by T$ (ts@deinmeister.de)
;
;compile with:
; TASMX.EXE /s /r /ml /m4 win002.asm    (TASM)
; ML.EXE /Dmasm /c /Cx /coff win002.asm (MASM)
;link with:
; TLINK32.EXE -c -Tpe -aa win002,,,import32.lib,,win002.res (TASM)
; LINK.EXE win002 kernel32.lib user32.lib win002.res /subsystem:windows (MASM)

;Everything written in part 0.5 won`t be repeated here - if something is still curious,
;a look into the first part may help

		.386
		.model flat, stdcall

;windows.inc for MASM needs the following option set:
	IFDEF masm
		option casemap :none
	ENDIF

include windows.inc


;the windows.inc shipped with TASM does not contain the new Windows 4.0 (=NT4,Win95)
;constants and structures. So I added them to the source:

	IFNDEF masm
		WS_EX_DLGMODALFRAME                  equ 1h
		WS_EX_NOPARENTNOTIFY                 equ 4h
		WS_EX_TOPMOST                        equ 8h
		WS_EX_ACCEPTFILES                    equ 10h
		WS_EX_TRANSPARENT                    equ 20h
		WS_EX_MDICHILD                       equ 00000040h
		WS_EX_TOOLWINDOW                     equ 00000080h
		WS_EX_WINDOWEDGE                     equ 00000100h
		WS_EX_CLIENTEDGE                     equ 00000200h
		WS_EX_CONTEXTHELP                    equ 00000400h
		WS_EX_RIGHT                          equ 00001000h
		WS_EX_LEFT                           equ 00000000h
		WS_EX_RTLREADING                     equ 00002000h
		WS_EX_LTRREADING                     equ 00000000h
		WS_EX_LEFTSCROLLBAR                  equ 00004000h
		WS_EX_RIGHTSCROLLBAR                 equ 00000000h
		WS_EX_CONTROLPARENT                  equ 00010000h
		WS_EX_STATICEDGE                     equ 00020000h
		WS_EX_APPWINDOW                      equ 00040000h
		WS_EX_OVERLAPPEDWINDOW               equ WS_EX_WINDOWEDGE OR WS_EX_CLIENTEDGE
		WS_EX_PALETTEWINDOW                  equ WS_EX_WINDOWEDGE OR WS_EX_TOOLWINDOW OR WS_EX_TOPMOST

	     WNDCLASSEX struc
        	cbSize       dd      ?
	        Style        dd      ?       ; class style
		lpfnWndProc  dd      ?
        	cbClsExtra   dd      ?
        	cbWndExtra   dd      ?
	        hInstance    dd      ?       ; instance handle
	        hIcon        dd      ?       ; class icon handle
	        hCursor      dd      ?       ; class cursor handle
	        hbrBackground dd     ?       ; class background brush
	        lpszMenuName dd      ?       ; menu name
	        lpszClassName dd     ?       ; far ptr to class name
	        hIconSm       dd     ?
	     WNDCLASSEX ends
	ENDIF


;the following constants describe the content of the message structure residing on the stack:
		MSGhWnd   equ 0
		MSGmsg    equ 4
		MSGwParam equ 8
		MSGlParam equ 12


	IFDEF masm
		SendMessageA equ SendMessageA@16
		ExitProcess equ ExitProcess@4
		GetModuleHandleA equ GetModuleHandleA@4
		RegisterClassExA equ RegisterClassExA@4
		LoadIconA equ LoadIconA@8
		LoadCursorA equ LoadCursorA@8
		CreateWindowExA equ CreateWindowExA@48
		GetMessageA equ GetMessageA@16
		DispatchMessageA equ DispatchMessageA@4
		DefWindowProcA equ DefWindowProcA@16
		PostQuitMessage equ PostQuitMessage@4
		MessageBoxA equ MessageBoxA@16
	ENDIF

		extrn GetModuleHandleA:near
		extrn RegisterClassExA:near
		extrn LoadIconA:near
		extrn LoadCursorA:near
		extrn CreateWindowExA:near
		extrn GetMessageA:near
		extrn DispatchMessageA:near
		extrn ExitProcess:near
		extrn DefWindowProcA:near
		extrn PostQuitMessage:near
		extrn MessageBoxA:near
		extrn SendMessageA:near

		.data

;Definition of the window class (with a Menu):
		OurWindowclass WNDCLASSEX <size WNDCLASSEX,CS_VREDRAW or CS_HREDRAW,Windowprocedure,0,0,0,0,0,COLOR_HIGHLIGHT,Menuname,Windowclassname,0>
		Windowhandle dd 0

;GetMessage requires a buffer for an incoming Message (one Message = 7 DWORDS):
		MessageBuffer dd 0,0,0,0,0,0,0

		Windowtitle db "ordinary standard window",0
		Windowclassname db "OurWindowclass",0
		Windowname db "Oooooh... A Window",0

;Name of Ressources:
		Menuname db "Win002menu",0
		Picturename db "Nuke",0
		Cursorname db "Fisch" 

		naffing db 0

;these constants are stand for themselves - change them, if you want ;-)
		WindowsizeInX equ 300
		WindowsizeInY equ 200
		WindowpositionInX equ 100
		WindowpositionInY equ 120


		.code

		_warp9mrsulu:

;many function require a handle identifying the running program
;GetModuleHandle (0) retrieves one

		push 0
		call GetModuleHandleA
		mov [OurWindowclass.hInstance],eax

;two ressources are loaded (the menu ressource is loaded automatically,
;if defined inside the window structure
		push offset Picturename
		push [OurWindowclass.hInstance]
		call LoadIconA
		mov [OurWindowclass.hIcon],eax
		push offset Cursorname
		push [OurWindowclass.hInstance]
		call LoadCursorA
		mov [OurWindowclass.hCursor],eax

;tell the OS about our new window class
		push offset OurWindowclass
		call RegisterClassExA


;create a window corresponding to our window class:
		push 0
		push [OurWindowclass.hInstance]
		push 0
		push 0
		push WindowsizeInY
		push WindowsizeInX
		push WindowpositionInY
		push WindowpositionInX
;windows.inc of TASM defines only the upper 16 bit of the window styles,
;windows.inc of MASM defines all 32 bit. Therefore the following IFDEF-crap:
	       IFNDEF masm
		push (WS_VISIBLE or WS_OVERLAPPED or WS_CAPTION or WS_SYSMENU or WS_THICKFRAME or WS_MINIMIZEBOX or WS_MAXIMIZEBOX) * 65536
	       ENDIF
	       IFDEF masm
		push WS_VISIBLE or WS_OVERLAPPED or WS_CAPTION or WS_SYSMENU or WS_THICKFRAME or WS_MINIMIZEBOX or WS_MAXIMIZEBOX
	       ENDIF
		push offset Windowname
		push offset Windowclassname
		push WS_EX_WINDOWEDGE + WS_EX_CLIENTEDGE 
		call CreateWindowExA
		mov Windowhandle,eax

;The most important place in a windows program: The Message Pump / Message Loop. Here the
;incoming Messages get preprocessed and get send to the corresponding window procedure

		MessagePumpStart:
		push 0
		push 0
		push 0
		push offset MessageBuffer
		call GetMessageA
		or eax,eax
		jz WM_QUIT_received
		push offset MessageBuffer
		call DispatchMessageA
		jmp MessagePumpStart


		WM_QUIT_received:
		push 0
		call ExitProcess

;------------
;the window procedure is called by DispatchMessage if the message
;applies to this window. The message and its parameters are on the stack. The number 4 in 
; [esp+4+MSGmsg] skips the EIP pushed on the stack by the call.

		Windowprocedure:

;only 2 messages are checked: WM_COMMAND for activated Menus and WM_DESTROY which
;indicates that the window is under destruction
;The rest is handled by DefaultWndProc of Windows.

		cmp dword ptr [esp+4+MSGmsg],WM_COMMAND
		jne noInterestingMessage

		 cmp dword ptr [esp+4+MSGwParam],999h
		 je Selfdestruction

		 cmp dword ptr [esp+4+MSGwParam],666h
		 je Dunnomessage

		 mov ecx,offset title1
		  cmp dword ptr [esp+4+MSGwParam],123h
		  je Wantsomemessage

		  mov ecx,offset title2
		  jmp Wantsomemessage

		noInterestingMessage:

		cmp dword ptr [esp+4+MSGmsg],WM_DESTROY
		jne DefWindowProcA


		Selfdestruction:
		push MB_OK or MB_APPLMODAL
		push offset Windowtitle
		push offset SayNo
		push Windowhandle
		call MessageBoxA
		push 0
		call PostQuitMessage
;set return value = 0
		xor eax,eax
;the "RET imm"-version of the RET instruction removes "imm" bytes from the stack while returning
;with imm = 16 we remove exactly 4 DWORDS which the window procedure got as parameters
		ret 16

		Wantsomemessage:
		push MB_OK
		push ecx
		push offset textinside
		push Windowhandle
		call MessageBoxA
		ret 16

		Dunnomessage:
		push MB_OK
		push offset naffing
		push offset naffing
		push Windowhandle
		call MessageBoxA
		ret 16

		.data
;some text for some dialogue boxes...
		title1 db "Fucking",0
		title2 db "Sucking",0
		textinside db "I knew that you want to, just look what you`ve done to the menu :-)",0
		SayNo db "Noooooooooooooooooooooooooo !",0

		.code
		end _warp9mrsulu